module.exports = {
    getType
};





function bSingle(cur_card, card_len) {
    if(card_len == 1) {
        return true;
    }
    return false;
}


function bDouble(cur_card, card_len) {
    if(card_len == 2) {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        if(card0 === card1 && card0 !== 13) 
            return true;
    }
    return false;
}


function bRocket(cur_card, card_len) {
    if(card_len == 2) {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        if(card0 === card1 && card0 ===13)
        return true;
    }
    return false;
}


function bBomb(cur_card, card_len) {
    if(card_len == 4) {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        if(card0 === card1 && card1 === card2 && card2 === card3) {
            return true;
        }
    }
    return false;
}


function bTripleA(cur_card, card_len) {
    if(card_len == 4)  {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        if (card0 !== card1) {        // first card is Single 
            if (card1 === card2 && card1 === card3)
                return 1;
        } 
        if (card2 !== card3) {      // last card is Single
            if (card0 === card1 && card1 === card2)
                return 0;
        }
    }
    return -1;
}


function bTripleAA(cur_card, card_len) {
    if(card_len == 5)  {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        let card4 = parseInt(cur_card[4]/4);
        if (card0 === card1) {        // first 2 cards are Double 
            if (card0 !== card2 && card2 === card3 && card2 === card4)
                return 1;
        } 
        if (card3 === card4) {       // last 2 cards are Double
            if (card0 === card1 && card1 === card2 && card0 !== card3)
                return 0;
        }
    }
    return -1;
}


function bSingleSequence(cur_card, card_len) {
    if(card_len >= 5 && card_len <= 12) {
        for(let i = 0; i<card_len-1; i++) {
            if((parseInt(cur_card[i+1]/4)) !== (parseInt(cur_card[i]/4)+1)) {   // check the cards if continue
                return false;
            }
            if((parseInt(cur_card[i]/4)) === 12 || (parseInt(cur_card[i]/4)) === 13) {   // not include 2 or Joker
                return false;
            }
        }
        return true;
    }
    return null;
}


function bDoubleSequence(cur_card, card_len) {
    if(card_len >= 6 && card_len%2 == 0) {
        for(let i = 0; i<card_len; i+=2) {
            if((parseInt(cur_card[i]/4)) === 12 || (parseInt(cur_card[i]/4)) === 13) {  // not include 2 or Joker
                return false;
            }
            if( (parseInt(cur_card[i]/4)) !== (parseInt(cur_card[i+1]/4)) ) {
                return false;
            }
            if( (parseInt(cur_card[i]/4)+1) !== (parseInt(cur_card[i+2]/4)) ) {
                return false;
            }
        }
        return true;
    }
    return false;
}


function bFlyAB(cur_card, card_len) {
    if(card_len == 8) {    // two triples with two singles
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        let card4 = parseInt(cur_card[4]/4);
        let card5 = parseInt(cur_card[5]/4);
        let card6 = parseInt(cur_card[6]/4);
        let card7 = parseInt(cur_card[7]/4);

        

        if(card0 !== card2 && card1 !== card2 && card0 !== card5 && card1 !== card5) {   // 2 single cards at first 2 position 'xyAAABBB'
            if(card2 == card3 && card2 == card4 && ((card2+1) == card5) && card5 == card6 && card6 == card7) {
                return 1;
            }
        }
        if(card0 !== card1 && card7 !== card1 && card0 !== card4 && card7 !== card4) {    //   xAAABBBy
            if(card1 == card2 && card1 == card3 && ((card1+1) == card4) && card4 == card5 && card5 == card6) {
                return 2;
            }
        }
        if(card6 !== card0 && card6 !== card3 && card0 !== card7 && card3 !== card7) {    //   AAABBBxy
            if(card0 == card1 && card1 == card2 && ((card0+1) == card3) && card3 == card4 && card4 == card5) {
                return 0;
            }
        }
    }
    return -1;
}
    
    
function bFlyAABB(cur_card, card_len) {
    if (card_len == 10) {       // two triples with 2 pairs
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        let card4 = parseInt(cur_card[4]/4);
        let card5 = parseInt(cur_card[5]/4);
        let card6 = parseInt(cur_card[6]/4);
        let card7 = parseInt(cur_card[7]/4);
        let card8 = parseInt(cur_card[8]/4);
        let card9 = parseInt(cur_card[9]/4);

        if(card0 == card1 && card0 !== card4 && card0 !== card7 && card2 == card3 && card2 !== card4 && card2 !== card7) {   //  xxyyAAABBB
            if(card4 == card5 && card5 == card6 && ((card4+1) == card7) && card7 == card8 && card8 == card9) {
                return 1;
            }
        }
        if(card0 == card1 && card0 !== card2 && card0 !== card5 && card8 == card9 && card8 !== card0 && card8 !== card5) {   //  xxAAABBByy
            if(card2 == card3 && card3 == card4 && ((card2+1) == card5) && card5 == card6 && card6 == card7) {
                return 2;
            }
        }
        if(card6 == card7 && card6 !== card0 && card6 !== card3 && card8 == card9 && card8 !== card0 && card8 !== card3) {   //  AAABBBxxyy
            if(card0 == card1 && card1 == card2 && ((card0+1) == card3) && card3 == card4 && card4 == card5) {
                return 0;
            }
        }
    }
    return -1;
}


function bTriple(cur_card, card_len) {
    if(card_len == 3) {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        if(card0 == card1 && card1 == card2){
            return cur_card;
        }
    }
    return null;
}


function getType(cur_card) {
    let cur_len = cur_card.length;
    let type = null;
    let res = {type: null,
               card: []}
    if(bSingle(cur_card, cur_len)) {
        res.type = 'Single';
        res.card = cur_card;
        return  res;
    }
    if(bDouble(cur_card, cur_len)) {
        res.type = 'Double';
        res.card = cur_card;
        return  res;
    }
    if(bRocket(cur_card, cur_len)) {
        res.type = 'Rocket';
        res.card = cur_card;
        return  res;
    }
    if(bBomb(cur_card, cur_len)) {
        res.type = 'Bomb';
        res.card = cur_card;
        return  res;
    }
    if(bTripleA(cur_card, cur_len) == 0) {
        res.type = 'TripleA';
        res.card = cur_card;
        return  res;
    }
    if(bTripleA(cur_card, cur_len) == 1) {
        res.type = 'TripleA';
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        res.card = [card1, card2, card3, card0];
        return  res;
    }
    if(bTripleAA(cur_card, cur_len) == 0) {
        res.type = 'TripleAA';
        res.card = cur_card;
        return  res;
    }
    if(bTripleAA(cur_card, cur_len) == 1) {
        res.type = 'TripleAA';
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        let card4 = parseInt(cur_card[4]/4);
        res.card = [card2, card3, card4, card0, card1];
        return  res;
    }
    if(bSingleSequence(cur_card, cur_len)) {
        res.type = 'SingleSequence';
        res.card = cur_card;
        return  res;
    }
    if(bDoubleSequence(cur_card, cur_len)) {
        res.type = 'DoubleSequence';
        res.card = cur_card;
        return  res;
    }
        /*
        AAABBBxy   0
        xyAAABBB   1
        xAAABBBy   2
        */

    if(bFlyAB(cur_card, cur_len) == 0) {
        res.type = 'FlyAB';
        res.card = cur_card;
        return  res;
    }
    if(bFlyAB(cur_card, cur_len) == 1) {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        let card4 = parseInt(cur_card[4]/4);
        let card5 = parseInt(cur_card[5]/4);
        let card6 = parseInt(cur_card[6]/4);
        let card7 = parseInt(cur_card[7]/4);
        res.type = 'FlyAB';
        res.card = [card2, card3, card4, card5, card6, card7, card0, card1];
        return  res;
    }
    if(bFlyAB(cur_card, cur_len) == 2) {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        let card4 = parseInt(cur_card[4]/4);
        let card5 = parseInt(cur_card[5]/4);
        let card6 = parseInt(cur_card[6]/4);
        let card7 = parseInt(cur_card[7]/4);
        res.type = 'FlyAB';
        res.card = [card1, card2, card3, card4, card5, card6, card0, card7];
        return  res;
    }
   

    /*
    AAABBBxxyy      0
    xxyyAAABBB      1
    xxAAABBByy      2
    */
    if(bFlyAABB(cur_card, cur_len) == 0) {
        res.type = 'FlyAABB';
        res.card = cur_card;
        return  res;
    }
    if(bFlyAABB(cur_card, cur_len) == 1) {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        let card4 = parseInt(cur_card[4]/4);
        let card5 = parseInt(cur_card[5]/4);
        let card6 = parseInt(cur_card[6]/4);
        let card7 = parseInt(cur_card[7]/4);
        let card8 = parseInt(cur_card[8]/4);
        let card9 = parseInt(cur_card[9]/4);
        res.type = 'FlyAABB';
        res.card = [card4, card5, card6, card7, card8, card9, card0, card1, card2, card3];
        return  res;
    }
    if(bFlyAABB(cur_card, cur_len) == 2) {
        let card0 = parseInt(cur_card[0]/4);
        let card1 = parseInt(cur_card[1]/4);
        let card2 = parseInt(cur_card[2]/4);
        let card3 = parseInt(cur_card[3]/4);
        let card4 = parseInt(cur_card[4]/4);
        let card5 = parseInt(cur_card[5]/4);
        let card6 = parseInt(cur_card[6]/4);
        let card7 = parseInt(cur_card[7]/4);
        let card8 = parseInt(cur_card[8]/4);
        let card9 = parseInt(cur_card[9]/4);
        res.type = 'FlyAABB';
        res.card = [card2, card3, card4, card5, card6, card7, card0, card1, card8, card9];
        return  res;
    }
    return res;
}





