const express = require('express');
const os = require('os');
var http = require('http');``
const app = express();
var server = http.createServer(app);
var io = require('socket.io')(server);

const cardType = require("./cardType.js");
const cardCompare = require("./cardCompare.js");


app.use(express.static('dist'));
//app.get('/api/getUsername', (req, res) => res.send({ username: os.userInfo().username }));



var vote = 0;
var user_num = 0;
var users = {'player1': '',
             'player2': '',
             'player3': ''
            };
var res_poker = {}       // save the each player's original cards as a list
var deal_poker = {}      // save the each player's currents cards as a list
var bool_landlord = false;

// players round order
var playerRoundOrder = {'player3': 'player1',
                        'player1': 'player2',
                        'player2': 'player3'
                        };

var playerAntiRoundOrder = {'player1': 'player3',
                            'player2': 'player1',
                            'player3': 'player2'
                            };


var pre_card = [];            // pre player's cards
var pre_cardType = null;
var pre_card_owner = null;  // pre card owner player
var pre_player = null;    // pre player's ID


var next_player = null;
var landlord_player = null; // landlord player ID

function poker_sort(arr){
    for(i=0;i<arr.length-1;i++){
        for(j=0;j<arr.length-1-i;j++){
            if(arr[j]>arr[j+1]){
                var temp=arr[j];
                arr[j]=arr[j+1];
                arr[j+1]=temp;
            }
        }
    }
    return arr;
}


function shuffle() {
    var pokers = new Array();
    for(var i = 0; i < 54; i++) {
      pokers[i]=i;
    }
    for (var i = 0; i < 54; i++) {
        var rd=parseInt(Math.random()*54);
        var b=pokers[i] ;
        pokers[i]= pokers[rd];
        pokers[rd]=b;
    }
    console.log('the shuffle pokers length: ', pokers.length)
    return pokers;
};


function poker_random() {
    var pokers = new Array();
    for(var i = 0; i < 54; i++) {
        pokers[i]=i;
    }
    for (var i = 0; i < 54; i++) {
        var rd=parseInt(Math.random()*(54-i));
        var b=pokers[i] ;
        pokers[i]= pokers[rd];
        pokers[rd]=b;
    }
    console.log('the shuffle pokers length: ', pokers.length)
    return pokers;
}

function deal(pokers) {
    var landlordpoker = [];
    var poker_1 = [];
    var poker_2 = [];
    var poker_3 = [];

    let x = 0, y = 0, z = 0;
    for(var i = 0; i < 54; i++) {
        if(i<17) {
            poker_1[i] = pokers[i];
        }
        if(i>=17 && i<34) {
            poker_2[x] = pokers[i];
            x++;
        }
        if(i>=34 && i<51) {
            poker_3[y] = pokers[i];
            y++;
        }
       if(i>=51) {
            landlordpoker[z] = pokers[i];
            z++;
        }
    };

    /*
    console.log('poker_1: ', poker_1)
    console.log('poker_2: ', poker_2)
    console.log('poker_3: ', poker_3)
    console.log('landlordpoker: ', landlordpoker)
    */

    poker_sort(poker_1);
    poker_sort(poker_2);
    poker_sort(poker_3);
    poker_sort(landlordpoker);

    result = {
        'player1': poker_1,
        'player2': poker_2,
        'player3': poker_3,
        'landlord_poker': landlordpoker
    };


    console.log(result.poker1)
    console.log(result.poker2)
    console.log(result.poker3)
    console.log(result.landlord_poker)


    return result;
}


function cardRule(cur_player, cur_card) {
   
}

/*
playerAntiRoundOrder = {'player1': 'player3',
                        'player2': 'player1',
                        'player3': 'player2'
                        }

playerRoundOrder = {'player3': 'player1',
                    'player1': 'player2',
                    'player2': 'player3'
                    };
*/

function roundOrder(cur_player) {
    console.log('the pre_player: ', pre_player, ' and the cur_player: ', cur_player, ' and the playerAntiRoundOrder[cur_player]: ', playerAntiRoundOrder[cur_player])
    if(pre_player == null && cur_player == landlord_player) {  // // first round, check the first player must be landlord
        console.log('landlord first turn')
        return true;
    }
    else if(pre_player !== null && playerAntiRoundOrder[cur_player] == pre_player) {
        console.log('right order turn')
        return true;
    } else {
        console.log('roundOrder return the false')
        return false;
    }
}


function card_type(cur_card) {
    let type = cardType.getType(cur_card);
    if(type == null) {
        console.log('there is no this type!')
        return;
    }
    return type;
};


function play_cards(cur_player, state, cur_card) {
    let the_cur_card = cur_card;
    if (state == 'play' && the_cur_card == []) {
        console.log('plz select card to play')
          // if card list is empty, will not continue
        return 2;
    }
    if(roundOrder(cur_player) == true) {
            console.log('roundOrder is true')
            if(state == 'pass') {
                pre_player = cur_player;
                return 1;
            }
            else if(state == 'play') {
                let res = card_type(the_cur_card)
                let tem_type = res.type;
                the_cur_card = res.card;
                if(tem_type == null) {
                    console.log('card type is not right');
                    return 2;
                }
                else {
                    if(pre_card_owner == cur_player || pre_cardType == null) {
                        // play any card in rules. you get this round.
                        pre_card = the_cur_card;
                        pre_cardType = tem_type;
                        pre_player = cur_player;
                        pre_card_owner = cur_player;
                        return 1;
                    }
                    else { 
                        // compare the cur_card and pre_card
                        console.log('pre_card type: ', pre_cardType, ' and cur card type: ', tem_type)
                        if(cardCompare.compareCard(pre_card, pre_cardType, the_cur_card, tem_type)) {
                            // you can beat the pre cards, so wait next peapole beat you
                            pre_player = cur_player;
                            pre_card_owner = cur_player;
                            pre_cardType = tem_type;
                            pre_card = the_cur_card;
                            return 1;
                        }
                        else {
                            console.log('compare cards false! you can not play this card')
                            return 4;
                        }
                    }
                }
            }
            else{
                console.log('state is wrong!')
                return 5;
            }
    }
    else {
        console.log('not your turn!');
        return 3;
    }
    
}



Array.prototype.indexOf = function(val) {
    for (var i = 0; i < this.length; i++) {
        if (this[i] == val) return i;
    }
    return -1;
};

Array.prototype.card_remove = function(val) {
    var index = this.indexOf(val);
    if (index > -1) {
        this.splice(index, 1);
    }
};

async function refresh_cards(cur_player, cur_card, callback) {
    let player_poker = deal_poker[cur_player];
    cur_card.forEach(function(element) {
        player_poker.card_remove(element);
    })
    callback(null, player_poker);
}








var poker_game = io.of('/card_game')
io.on('connection', function (socket) {

    socket.join('DouDiZhu_room1');
    user_num++;

    if(user_num == 1) {
        let id = 'player1';
        users['player1']= socket.id;
        console.log('a user connected: ', users['player1']);
        console.log('user number: ', user_num);
        if (io.sockets.connected[users['player1']]) {
            console.log('check the user socket.id: ', users['player1'], 'and send the user id.');
            io.sockets.connected[users['player1']].emit('player ID', { id });
        } else {
            console.log('socket.io connected fail')
        }
    }

    if(user_num == 2) {
        let id = 'player2';
        users['player2']= socket.id;
        console.log('a user connected: ', users['player2']);
        console.log('user number: ', user_num);
        if (io.sockets.connected[users['player2']]) {
            console.log('check the user socket.id: ', users['player2'], 'and send the user id.');
            io.sockets.connected[users['player2']].emit('player ID', { id });
        }
        else {
            console.log('socket.io connected fail')
        }
    }

    if(user_num == 3) {
        let id = 'player3';
        users['player3']= socket.id;
        console.log('a user connected: ', users['player3']);
        console.log('user number: ', user_num);
        if (io.sockets.connected[users['player3']]) {
            console.log('check the user socket.id: ', users['player3'], 'and send the user id.');
            io.sockets.connected[users['player3']].emit('player ID', { id });
        }
    }

   
    
    socket.on('game_begin', function(data) {
        if(data.id == 'player1' || data.id == 'player2' || data.id == 'player3') {
            vote++;
        }
        console.log('get socket of Game Begin, and the date:', data, ', right now the vote number is: ', vote)
        if(vote === 3) {
            //var pokers = shuffle();
            var pokers = poker_random();
            res_poker = deal(pokers);
            console.log('deal poker ready')
            for(var i = 1; i <= vote; i++) {
                if(i === 1) {
                    deal_poker['player1'] = res_poker['player1'];
                }
                if(i === 2) {
                    deal_poker['player2'] = res_poker['player2'];
                }
                if(i === 3) {
                    deal_poker['player3'] = res_poker['player3'];
                }
                let ID = String('player'+i);
                let player_poker = deal_poker[ID];
                if (io.sockets.connected[users[ID]]) {
                    console.log('check the user socket.id: ', users[ID]);
                    io.sockets.connected[users[ID]].emit('deal poker', { player_poker });
                }
            }
        }
    });


    socket.on('bid_landlord', function(data){
        let Id = data.ID;
        console.log('the landlord ID: ', Id)
        if(Id !== null && bool_landlord == false) {
            let landlord_poker = res_poker['landlord_poker'];
            console.log(landlord_poker)
            io.to('DouDiZhu_room1').emit('landlord poker', { landlord_poker });

            let old_player_poker = deal_poker[Id];
            let player_poker = old_player_poker.concat(landlord_poker);
            //console.log(player_poker)
            poker_sort(player_poker);
            deal_poker[Id] = player_poker;
            landlord_player = Id;
            if (io.sockets.connected[users[Id]]) {
                console.log('in socket bid_landlord,   check the user socket.id: ', users[Id]);
                io.sockets.connected[users[Id]].emit('deal poker', { player_poker });
            }
            bool_landlord = true;
        }
    });


    socket.on('cards_play', function(data) {
        let cur_player = data.playerID;
        let state = 'play';
        let cur_card = data.cards;
        let result = play_cards(cur_player, state, cur_card);
        console.log('the cards play results: ', result)

        if(result == 4) {
            console.log('card play socket, result 4, cannot play this card compare cards false')
            //let message = 'you cannot play this cards';
            let message = 4;
            if (io.sockets.connected[users[cur_player]]) {
                io.sockets.connected[users[cur_player]].emit('sys_warning', { message });
            }
        }
        if(result == 3) {
            console.log('card play socket, result 3, not your turn')
            let message = 3;
            if (io.sockets.connected[users[cur_player]]) {
                io.sockets.connected[users[cur_player]].emit('sys_warning', { message });
            }
        }
        if(result == 2) {
            console.log('card play socket, result 2, card type not right')
            let message = 2;
            if (io.sockets.connected[users[cur_player]]) {
                io.sockets.connected[users[cur_player]].emit('sys_warning', { message });
            }
        }
        if(result == 1) {
            console.log('before update cards, ', deal_poker[cur_player])
            refresh_cards(cur_player, cur_card, async (err, player_poker) => {
                deal_poker[cur_player] = player_poker;
                console.log('refesh the curplayer hands cards')
                console.log('after update cards, ', deal_poker[cur_player])
                if (io.sockets.connected[users[cur_player]]) {
                    io.sockets.connected[users[cur_player]].emit('deal poker', { player_poker });
                }
                io.to('DouDiZhu_room1').emit('card played', { cur_player, cur_card });

                if(deal_poker[cur_player].length == 0) {
                    io.to('DouDiZhu_room1').emit('win game', { cur_player });
                }
            })
        }
    })

    socket.on('pass_turn', function(data) {
        let cur_player = data.playerID;
        let state = 'pass';
        let cur_card = [];
        let result = play_cards(cur_player, state, cur_card);
        console.log('the cards play results: ', result, ' and the pre_player is: ', pre_player, ' and the cur_player is: ', cur_player)
        
        if (result == 3) {
            //let message = 'it is not your trun, please wait';
            let message = 3;
            if (io.sockets.connected[users[cur_player]]) {
                io.sockets.connected[users[cur_player]].emit('sys_warning', { message });
            }
        }
        else if(result == 1) {
            let message = 'pass succeed';
            console.log('pass_turn res == 1')
            io.to('DouDiZhu_room1').emit('passturn', { cur_player });
        }
    })



    socket.on('disconnect', function () {
        console.log('a user disconnected');
        user_num--;
        vote == 0;
    });

});




server.listen(8080, () => console.log('Listening on port 8080!'));